"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Awaitable = void 0;
exports.needsToBeAwaited = needsToBeAwaited;
const type_utils_1 = require("@typescript-eslint/type-utils");
const tsutils = __importStar(require("ts-api-utils"));
var Awaitable;
(function (Awaitable) {
    Awaitable[Awaitable["Always"] = 0] = "Always";
    Awaitable[Awaitable["Never"] = 1] = "Never";
    Awaitable[Awaitable["May"] = 2] = "May";
})(Awaitable || (exports.Awaitable = Awaitable = {}));
function needsToBeAwaited(checker, node, type) {
    // can't use `getConstrainedTypeAtLocation` directly since it's bugged for
    // unconstrained generics.
    const constrainedType = !tsutils.isTypeParameter(type)
        ? type
        : checker.getBaseConstraintOfType(type);
    // unconstrained generic types should be treated as unknown
    if (constrainedType == null) {
        return Awaitable.May;
    }
    // `any` and `unknown` types may need to be awaited
    if ((0, type_utils_1.isTypeAnyType)(constrainedType) || (0, type_utils_1.isTypeUnknownType)(constrainedType)) {
        return Awaitable.May;
    }
    // 'thenable' values should always be be awaited
    if (tsutils.isThenableType(checker, node, constrainedType)) {
        return Awaitable.Always;
    }
    // anything else should not be awaited
    return Awaitable.Never;
}
//# sourceMappingURL=needsToBeAwaited.js.map